#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#ifdef USE_GNOME
#      include <gnome.h>
#      include <zvt/zvtterm.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "data.h"
#include "xtext.h"
#include "palette.h"
#define ADD 1
#define MISC 0

extern _gui *gui;
extern _data *data;

void
on_b_save_clicked ()
{

    if(data->bul.status==FALSE)
    {
        GtkWidget *button;
        gpointer *id;
        if(gui->win.filesel==NULL)
        {
            gui->win.filesel=create_fileselection1();
            button=GTK_WIDGET(gtk_object_get_data (GTK_OBJECT(gui->win.filesel),"ok_button2"));

            GPOINTER_TO_INT(id)=gtk_object_get_data (GTK_OBJECT(gui->win.filesel),"id");

            gtk_signal_disconnect (GTK_OBJECT(button), GPOINTER_TO_INT(id));


            gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (gui->win.filesel)->ok_button), "clicked",
                                GTK_SIGNAL_FUNC (guardar),
                                GTK_OBJECT(gui->win.filesel));
            gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (gui->win.filesel)->ok_button), "clicked",
                                GTK_SIGNAL_FUNC (destroy_files),
                                NULL);

            gtk_widget_show(gui->win.filesel);
        }
        else gdk_window_raise(gui->win.filesel->window);
    }
}



void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{

    on_b_quit_clicked(NULL,NULL);
    
}


void
on_b_start_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
    watcher *temp=gui->punta;

    if(data->bul.status!=TRUE)
    {
        data->bul.status=TRUE;
        while(temp!=NULL)
        {
            temp->fp=fopen(temp->path,"r");
            if (temp->fp!=NULL)
            {
                fseek(temp->fp,-1,SEEK_END);
#ifdef  DEBUG
                g_print("archivo abierto %s\n",temp->path);
#endif
            }
#ifdef  DEBUG
            else g_print("archivo: %s no se abrio",temp->path);
#endif
            temp=temp->next;
        gtk_statusbar_pop(GTK_STATUSBAR(gui->wid.statusbar1),gui->mess_id);
        gtk_statusbar_push(GTK_STATUSBAR(gui->wid.statusbar1),gui->mess_id,_("The Selected file are beeing watched for words!"));
        gui->tag=gtk_timeout_add(10,(GtkFunction) update,NULL);
        }
    }
}


void
on_b_stop_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
    watcher *temp=gui->punta;
    if(data->bul.status!=FALSE)
    {
        data->bul.status=FALSE;
        gtk_timeout_remove( gui->tag );
        while(temp!=NULL)
        {
            fclose(temp->fp);
#ifdef  DEBUG
            g_print("archivo Cerrado %s\n",temp->path);
#endif
            temp=temp->next;
        }

        gtk_statusbar_pop(GTK_STATUSBAR(gui->wid.statusbar1),gui->mess_id);
        gtk_statusbar_push(GTK_STATUSBAR(gui->wid.statusbar1),gui->mess_id,_("Thers's no files beeing watched right now!"));
    }
}

/*---------------------------CONFIGURE----------------------------------*/

void
on_b_configure_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
    if(data->bul.status!=FALSE)
    {
        GtkWidget *window,*label,*button;
        window=gtk_dialog_new();
        button =gtk_button_new_with_label ("OK");
        gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->action_area),
                            button, TRUE, TRUE, 0);
        gtk_signal_connect (GTK_OBJECT (button), "clicked",
                                  GTK_SIGNAL_FUNC(destroy_wid), window);
        gtk_widget_show (button);
        label = gtk_label_new (_(" The Watcher is running please \nstop it first "));
        gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->vbox),
                            label, TRUE, TRUE, 0);
        gtk_widget_show(label);

        gtk_widget_show(window);
    }
    else gtk_widget_show(gui->win.w_config);
}


                  /*--------------------------ADD-------------------*/
void
on_b_add_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

    if(gui->win.add==NULL)
    {
        gui->win.add=create_w_add();
        gtk_widget_show(gui->win.add);
    }
    else gdk_window_raise(gui->win.add->window);
}

void
on_b_add_word_clicked()
{
    if(gui->win.add_word==NULL)
    {
        gui->win.add_word=create_w_add_word();
        gtk_widget_show(gui->win.add_word);
    }
    else gdk_window_raise(gui->win.add_word->window);
}


void
on_b_brow_path_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

    if(gui->win.filesel==NULL)
    {
        gui->win.filesel=create_fileselection1();
        gtk_widget_show(gui->win.filesel);
    }
    else gdk_window_raise(gui->win.filesel->window);

}

void
on_b_filesel_ok_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

    gtk_entry_set_text (GTK_ENTRY (gui->wid.e_path), gtk_file_selection_get_filename (GTK_FILE_SELECTION (user_data)) );
    destroy_files();
}

void
on_b_color_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

    palette_edit(ADD);

}

void
on_b_ok_add_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
    gchar *path;

        if (data->glob.n_color!=-1 && strlen( gtk_entry_get_text(GTK_ENTRY(gui->wid.e_path) ))!=0 )
        {

            path=g_malloc0(strlen(gtk_entry_get_text(GTK_ENTRY(gui->wid.e_path)))+1);
            strcpy(path,gtk_entry_get_text(GTK_ENTRY(gui->wid.e_path)));

            g_print("path: %s\n",path);

                add_watcher(path,0,NULL,data->glob.n_color);
                add_watcher_tree(path);
                data->glob.n_color=-1;
        }
#ifdef  DEBUG
        else g_print("Color o path no elegido\n");
#endif
        destroy_wadd();
}

void
on_b_mod_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
    palette_edit(2); //This SUCKS SO MUCH, but i like polimorphing things 8)
}


                  /*-----------------------DEL-----------------------*/

void
on_b_del_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{ /*
    if(state==FALSE)
    {
        //tenemos un watcher, borrar todo el watcher del p_philez;
        //borrar la linea en el tree
    }
    else
    {
        //tenemos un word, buscarla en el watcher y borrarla
        //borrar la linea en el tree

        }*/

    GtkWidget *owner;
    GtkLabel *label;
    gchar    *name;
    watcher  *temp;
    if(data->bul.que==FALSE)
    {
        label = GTK_LABEL (GTK_BIN (data->actual.item_actual)->child);
        gtk_label_get (label, &name);

        gtk_widget_ref (gui->wid.tree1);
        owner = GTK_TREE(gui->wid.tree1)->tree_owner;
        gtk_container_remove (GTK_CONTAINER(gui->wid.tree1), data->actual.item_actual);
        if (gui->wid.tree1->parent == NULL)
        {
            gtk_tree_item_expand (GTK_TREE_ITEM(owner));
            gtk_tree_item_set_subtree (GTK_TREE_ITEM(owner), gui->wid.tree1);
        }
        else  gtk_widget_unref (gui->wid.tree1);
#ifdef  DEBUG
        g_print("borrado item_actual osea un WATCHER\n");
#endif
        watcher_borrar(name);


    }
    else
    {
        label = GTK_LABEL (GTK_BIN ( GTK_TREE(data->actual.item_word->parent)->tree_owner   )->child);
        gtk_label_get (label, &name);
#ifdef  DEBUG
        g_print("parent path: %s\n",name);
#endif
        temp=watcher_find(name);
        if (temp!=NULL)
        {
            label = GTK_LABEL (GTK_BIN (data->actual.item_word)->child);
            gtk_label_get (label, &name);

        }
#ifdef  DEBUG
        else g_print("Wactcher no encontrado");
#endif
        gtk_container_remove (GTK_CONTAINER(GTK_TREE (data->actual.item_word->parent)), data->actual.item_word);
#ifdef  DEBUG
        g_print("borrado un item_word osea un WORD\n");
#endif
        word_borrar(temp,name);
    }

}


void
on_b_quit_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
    on_b_stop_clicked(NULL,NULL);
    if(gui->win.window1->window!=NULL)
    {
        gdk_window_get_size(gui->win.window1->window, &gui->w1_ancho, &gui->w1_altura);

        gdk_window_get_position(gui->win.window1->window, &gui->xw1, &gui->yw1);
    }

    if (gui->win.w_config->window!=NULL)
        gdk_window_get_size(gui->win.w_config->window, &gui->wc_ancho, &gui->wc_altura);

    save_config();
    save_palette();
    g_print("TERMINO\n");

    gtk_exit(0);
}

void
on_b_ok_add_word_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
    watcher   *donde=NULL;
    GtkLabel *label;
    gchar    *name;
    gchar    *word;

    if (data->actual.item_actual!=NULL)
    {
        word=gtk_entry_get_text(GTK_ENTRY(user_data));

        if(strlen(word)!=0 && gui->punta!=NULL)
        {
            add_word_tree(word);

            label = GTK_LABEL (GTK_BIN (data->actual.item_actual)->child);
            gtk_label_get (label, &name);

            donde=watcher_find(name);
            add_word_struct(donde,word);

#ifdef  DEBUG
            if (donde==NULL)
            {
            g_print("ERROR");
            g_print("name: %s word: %s\n", name, word);
            }
            else
                g_print("Insertado name: %s word: %s\n", name, word);
#endif
        }
    }
    destroy_addword();
}
/************************** MISC CALLBACKS**********************/

void on_mb_color_clicked()
{
    palette_edit(0);
}

void on_mb_pop_clicked (GtkButton       *button,
                        gpointer         user_data)
{
if (GTK_TOGGLE_BUTTON (GTK_WIDGET(user_data))->active)
        {
            data->bul.bzvt=TRUE;
            /* If control reaches here, the toggle button is down */
        
        } else
        {
            data->bul.bzvt=FALSE;
            /* If control reaches here, the toggle button is up */
        }

#ifdef USE_IMLIB
            gtk_widget_set_sensitive (gui->wid.m_check_tint, data->bul.bzvt);
#endif
}
void on_mb_tint_clicked (GtkButton       *button,
                        gpointer         user_data)
{
    if (GTK_TOGGLE_BUTTON (GTK_WIDGET(user_data))->active)
        {
            data->bul.btint=TRUE;
            /* If control reaches here, the toggle button is down */

        } else {
            data->bul.btint=FALSE;
            /* If control reaches here, the toggle button is up */
        }
    if(gui->wid.text1!=NULL)
    {
        if(gui->wid.text1!=NULL && data->bul.bxtext)
        {
#ifdef USE_IMLIB
            gtk_xtext_set_background((GtkXText*) gui->wid.text1,(void *)-1,data->bul.bzvt,data->bul.btint);
            gtk_widget_queue_draw (GTK_WIDGET(gui->wid.text1));
#endif
        }

        g_print("flag tint= %d  zvt= %d\n",data->bul.btint,data->bul.bzvt);
    }
}


void on_mb_font_clicked (GtkButton       *button,
                        gpointer         user_data)
{
    if(gui->win.fontsel==NULL)
    {
        gui->win.fontsel=create_fontselectiondialog1 (user_data);
        gtk_widget_show(gui->win.fontsel);
    }
    else gdk_window_raise(gui->win.fontsel->window);

}
void on_mb_zvt_clicked (GtkButton       *button,
                        gpointer         user_data)
{
if (GTK_TOGGLE_BUTTON (GTK_WIDGET(user_data))->active)
        {
            data->bul.bpop=TRUE;
            /* If control reaches here, the toggle button is down */
        
        } else
        {
            data->bul.bpop=FALSE;
            /* If control reaches here, the toggle button is up */
        }

}
void
font_selection_ok (GtkWidget              *w,
                   GtkFontSelectionDialog *fs)
{
    GtkWidget *text=gtk_object_get_data(GTK_OBJECT(fs),"text");

    if (gui->ufont!=NULL)
    {
        g_free (gui->ufont);
        gui->ufont=NULL;
    }
    gui->ufont = gtk_font_selection_dialog_get_font_name (fs);
    if(gui->ufont!=NULL)
    {
        gdk_font_unref(gui->fixed_font);
        gui->fixed_font = gdk_font_load (gui->ufont);
    }

    if(data->bul.bzvt==TRUE)  gtk_xtext_set_font((GtkXText*) gui->wid.text1,gui->fixed_font,gui->ufont);

    gtk_text_backward_delete(GTK_TEXT(text),gtk_text_get_length(GTK_TEXT(text)));
    gtk_text_insert(GTK_TEXT (text), gui->fixed_font , NULL, NULL , _("Selected Font"), -1);

    destroy_fonts();

}
void destroy_wadd()
{
    gtk_widget_destroy(gui->win.add);
    gui->win.add=NULL;
}
void destroy_files()
{
    gtk_widget_destroy(gui->win.filesel);
    gui->win.filesel=NULL;
}
void destroy_addword()
{
    gtk_widget_destroy(gui->win.add_word);
    gui->win.add_word=NULL;
}
void destroy_fonts()
{
    gtk_widget_destroy(gui->win.fontsel);
    gui->win.fontsel=NULL;
}
void destroy_wid(GtkWidget *parakesirveesto, GtkWidget *wid)
{
    gtk_widget_destroy(wid);

}