/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include <gtk/gtk.h>
#include <gdk/gdk.h>

#ifdef USE_IMLIB
#      include <gdk_imlib.h>
#endif

#include "interface.h"
#include "support.h"
#include "callbacks.h"
#include "data.h"
#include "xtext.h"


_gui *gui;
_data *data;
GdkColor xcolors[] =
{
   {0, 0xffff, 0xffff, 0xffff}, /* 0  white */
   {0, 0, 0, 0},
   {0, 0, 0, 0xcccc},           /* 2  blue */
   {0, 0, 0xcccc, 0},           /* 3  green */
   {0, 0xcccc, 0, 0},           /* 4  red */
   {0, 0xbbbb, 0xbbbb, 0},      /* 5  yellow/brown */
   {0, 0xbbbb, 0, 0xbbbb},      /* 6  purple */
   {0, 0xffff, 0xaaaa, 0},      /* 7  orange */
   {0, 0xffff, 0xffff, 0},      /* 8  yellow */
   {0, 0, 0xffff, 0},           /* 9  green */
   {0, 0, 0xbbbb, 0xbbbb},      /* 10 aqua */
   {0, 0, 0xffff, 0xffff},      /* 11 light aqua */
   {0, 0, 0, 0xffff},           /* 12 blue */
   {0, 0xffff, 0, 0xffff},      /* 13 pink */
   {0, 0x7777, 0x7777, 0x7777}, /* 14 grey */
   {0, 0x9999, 0x9999, 0x9999}, /* 15 light grey */
   {0, 0xffff, 0, 0xffff},      /* 16 pink */
   {0, 0x7777, 0x7777, 0x7777}, /* 17 grey */
/*   {0, 0x9999, 0x9999, 0x9999}  18 light grey */
   /*     { 0, 0xf8f4, 0xffff, 0xbbbb }, *//* 16 light yellow for tooltips */
};

static void make_dir(void) /*taken from xmms*/
{
        gchar *filename;
        filename = g_strconcat(g_get_home_dir(), "/.sportal", NULL);
        mkdir(filename, S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH);
        g_free(filename);

}


int
main (int argc, char *argv[])
{

  gui = g_new(_gui,1);
  data= g_new(_data,1);
  gui->win.filesel=NULL;
  gui->win.add=NULL;
  gui->win.add_word=NULL;
  gui->win.colorsel=NULL;
  gui->win.fontsel=NULL;

  data->glob.color_add[0]=-1;
  data->glob.color_add[1]=-1;
  data->glob.color_add[2]=-1;
  data->glob.n_color=-1;

  data->bul.bzvt=FALSE;
  data->bul.btint=FALSE;
  
  gui->ufont=NULL;



  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");
  gtk_init(&argc,&argv);
#ifdef USE_IMLIB
  gdk_imlib_init ();
#endif
  gui->win.w_config = create_w_config();

  make_dir();
  read_config();
  read_palette();
  if(data->bul.bzvt)
  {
      /*gtk_text_insert (GTK_TEXT (gui->wid.m_t_color), NULL, &xcolors[0], NULL,_("Selected Color"), -1);*/
  }

  gui->win.window1 = create_window1 ();
  gtk_widget_set_usize(gui->win.w_config,gui->wc_ancho,gui->wc_altura);
  gtk_widget_show(gui->win.window1);

  if(gui->ufont==NULL)
  {
      gui->ufont=g_malloc0(strlen("fixed"));
      strcpy(gui->ufont,"fixed");
  }
  gui->fixed_font = gdk_font_load (gui->ufont);
  gtk_text_insert(GTK_TEXT (gui->wid.m_t_font), gui->fixed_font , NULL, NULL , _("Selected Font"), -1);
  if (data->bul.bzvt)
  {
      gtk_xtext_set_font((GtkXText*) gui->wid.text1,gui->fixed_font,NULL);
      gtk_xtext_set_palette ((GtkXText*) gui->wid.text1,xcolors);
#ifdef USE_IMLIB
      gtk_xtext_set_background((GtkXText*) gui->wid.text1,(void *)-1,data->bul.bzvt,data->bul.btint);
#else
      gtk_xtext_set_background((GtkXText*) gui->wid.text1,(void *)-1,data->bul.bzvt,0);
#endif
  }
  
  gtk_main ();
  return 0;
}
