#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <gtk/gtk.h>

#include "palette.h"

#include "xtext.h"
#include "data.h"
extern _gui *gui;
extern _data *data;
GtkWidget *palwin=NULL;
GtkWidget *c_button=NULL;
extern GdkColor xcolors[];

void
palette_edit (int opcion)
{
   char tbuf[64];
   GtkWidget *wid, *mainbox, *hbox, *vbox,
            *bbox, *bbbox;
   GtkStyle *style;
   int i;

   if (palwin)
   {
      gdk_window_show (palwin->window);
      return;
   }

   palwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);

   if(opcion==0)
       gtk_signal_connect (GTK_OBJECT (palwin), "destroy",
                           GTK_SIGNAL_FUNC (palette_edit_destroy_callback), NULL);
   else
       gtk_signal_connect (GTK_OBJECT (palwin), "destroy",
                           GTK_SIGNAL_FUNC (destroy_callback),NULL);


   mainbox = gtk_vbox_new (0, 5);
   gtk_container_set_border_width (GTK_CONTAINER (mainbox), 2);
   gtk_container_add (GTK_CONTAINER (palwin), mainbox);
   gtk_widget_show (mainbox);

   hbox = gtk_hbox_new (0, 0);
   gtk_container_add (GTK_CONTAINER (mainbox), hbox);
   gtk_widget_show (hbox);

   vbox = gtk_vbox_new (0, 0);
   gtk_container_add (GTK_CONTAINER (hbox), vbox);
   gtk_widget_show (vbox);

   wid = gtk_hseparator_new ();
   gtk_container_add (GTK_CONTAINER (mainbox), wid);
   gtk_widget_show (wid);

   bbox = gtk_hbox_new (0, 1);
   gtk_box_pack_end (GTK_BOX (mainbox), bbox, 0, 0, 0);
   gtk_widget_show (bbox);

   bbbox = gtk_hbox_new (0, 1);
   gtk_box_pack_end (GTK_BOX (bbox), bbbox, 0, 0, 0);
   gtk_widget_set_usize (bbbox, 100, 0);
   gtk_widget_show (bbbox);

   for (i = 0; i < 16; i++)
   {
      style = gtk_style_new ();
      style->bg[0] = xcolors[i];
      snprintf (tbuf, sizeof tbuf, "Color %d", i);
      wid = gtk_button_new_with_label (tbuf);
      gtk_container_add (GTK_CONTAINER (vbox), wid);
      if (opcion==0) /*MISC*/
      {
          gtk_object_set_user_data (GTK_OBJECT (wid), &xcolors[i]);
          gtk_signal_connect (GTK_OBJECT (wid), "clicked",
                              GTK_SIGNAL_FUNC (palette_editcolor), &xcolors[i]);
      }
      else
      {
          gpointer *color;
          GPOINTER_TO_INT(color)=i;
          gtk_object_set_user_data (GTK_OBJECT (wid), color);
          if (opcion==1)
              gtk_signal_connect (GTK_OBJECT (wid), "clicked",
                                  GTK_SIGNAL_FUNC (put_color),  (gpointer*) wid);
          else
              gtk_signal_connect (GTK_OBJECT (wid), "clicked",
                                  GTK_SIGNAL_FUNC (mod_color),  (gpointer*) wid);

      }
      
      gtk_widget_set_usize (wid, 150, 0);
      gtk_widget_set_style (wid, style);
      gtk_widget_show (wid);
      gtk_style_unref (style);

      if (i == 7)
      {
          vbox = gtk_vbox_new (0, 0);
          gtk_container_add (GTK_CONTAINER (hbox), vbox);
          gtk_widget_show (vbox);
      }
   }

   if(opcion==0)
       gtkutil_button (palwin,NULL, "OK",
                          gtkutil_destroy, palwin, bbbox);
   else
       gtkutil_button (palwin,NULL, "Cancel",
                       gtkutil_destroy, palwin, bbbox);

   gtk_widget_show (palwin);
}

int
destroy_callback ()
{
    gtk_widget_destroy(palwin);
    palwin=NULL;
    return 0;
}

int
palette_edit_destroy_callback ()
{
   palwin = 0;
   palette_prepare ();
   return 0;
}


void
palette_prepare ()
{
    if (data->bul.bzvt==TRUE) gtk_xtext_set_palette ((GtkXText*) gui->wid.text1,xcolors);
    g_print("preparar paleta para mandar a xtext\n");
}
void
palette_editcolor (GtkWidget * button, GdkColor * color)
{
   gdouble col[3];
   GtkWidget *dialog;

   col[0] = color->red / 65535.0;
   col[1] = color->green / 65535.0;
   col[2] = color->blue / 65535.0;

   dialog = gtk_color_selection_dialog_new ("Select color");
   gtk_signal_connect (GTK_OBJECT (((GtkColorSelectionDialog *) dialog)->ok_button),
                       "clicked", GTK_SIGNAL_FUNC (palette_okclicked), dialog);
   gtk_signal_connect (GTK_OBJECT (((GtkColorSelectionDialog *) dialog)->cancel_button),
                       "clicked", GTK_SIGNAL_FUNC (gtkutil_destroy), dialog);
   gtk_widget_set_sensitive (((GtkColorSelectionDialog *) dialog)->help_button, FALSE);
   gtk_color_selection_set_color ((GtkColorSelection *) ((GtkColorSelectionDialog *) dialog)->colorsel,
                                  col);
   gtk_widget_show (dialog);
   c_button = button;
}

void
palette_okclicked (GtkWidget * ok, GtkWidget * color_dialog)
{
   GdkColor *color;
   gdouble col[3];
   GtkStyle *style;

   color = gtk_object_get_user_data (GTK_OBJECT (c_button));

   gtk_color_selection_get_color ((GtkColorSelection *)
                                  ((GtkColorSelectionDialog *) color_dialog)->colorsel,
                                  col);

   /* is this line correct ?? */
   gdk_colormap_free_colors (gtk_widget_get_colormap (c_button), color, 1);

   color->red = (guint16) (col[0] * 65535.0);
   color->green = (guint16) (col[1] * 65535.0);
   color->blue = (guint16) (col[2] * 65535.0);

   color->pixel = (gulong) ((color->red & 0xff00) * 256 +
             (color->green & 0xff00) +
        (color->blue & 0xff00) / 256);
   gdk_color_alloc (gtk_widget_get_colormap (ok), color);

   style = gtk_style_new ();
   memcpy (&style->bg[0], color, sizeof (GdkColor));
   gtk_widget_set_style (c_button, style);

   gtk_widget_destroy (color_dialog);
}
void
put_color                       (GtkButton       *button,
                                  gpointer         user_data)
{
    data->glob.n_color=GPOINTER_TO_INT(gtk_object_get_user_data(GTK_OBJECT (user_data)));
    g_print("Color %d",data->glob.n_color);
    destroy_callback ();
}

void
mod_color                      (GtkButton       *button,
                                gpointer         user_data)
{
    GtkLabel *label;
    gchar    *name;
    watcher  *temp;

    if(data->bul.que==FALSE)
    {
        label = GTK_LABEL (GTK_BIN (data->actual.item_actual)->child);
        gtk_label_get (label, &name);
    }
    else
    {
        label = GTK_LABEL (GTK_BIN ( GTK_TREE(data->actual.item_word->parent)->tree_owner   )->child);
        gtk_label_get (label, &name);
    }
    temp=watcher_find(name);

    if (temp!=NULL) temp->color=GPOINTER_TO_INT(gtk_object_get_user_data(GTK_OBJECT (user_data)));
    else g_print("b_mod: watcher_find()==NULL");
    destroy_callback ();
}

GtkWidget *
gtkutil_button (GtkWidget * win, char *stock, char *labeltext,
                void *callback, gpointer userdata, GtkWidget * box)
{
   GtkWidget *button, *label, *hbox;

   hbox = gtk_hbox_new (0, 0);
   gtk_widget_show (hbox);

   button = gtk_button_new ();
   gtk_signal_connect (GTK_OBJECT (button), "clicked",
                       GTK_SIGNAL_FUNC (callback), userdata);
   gtk_widget_show (button);

   if (labeltext)
   {
      label = gtk_label_new (labeltext);
      gtk_container_add (GTK_CONTAINER (hbox), label);
      gtk_widget_show (label);
   }
   gtk_container_add (GTK_CONTAINER (button), hbox);
   if (box)
      gtk_container_add (GTK_CONTAINER (box), button);

   return button;
}
void
gtkutil_destroy (GtkWidget * igad, GtkWidget * dgad)
{
   gtk_widget_destroy (dgad);
}
